package org.steveshipway.cheshirecat.cmd;

import java.util.ArrayList;
import java.util.List;

import org.steveshipway.cheshirecat.CheshireCat;
import org.steveshipway.cheshirecat.item.ItemWand;
import org.steveshipway.cheshirecat.lib.Constants;

import net.minecraft.command.ICommand;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.MathHelper;
// Minecraft 1.7
//import org.steveshipway.blueprints.util17.*;
// Minecraft 1.8
import net.minecraft.util.BlockPos;
import org.steveshipway.blueprints.util18.*;

public class WandCommand  implements ICommand {
		  private List aliases;
		  private String wandCommand = "wand";
		  
		  public WandCommand()
		  {
			this.wandCommand = CheshireCat.wandCommand; // inherit from the config file
		    this.aliases = new ArrayList();
		    this.aliases.add(this.wandCommand);
		  }

		  @Override
//		  public String getCommandName()
		  public String getName()
		  {
		    return this.wandCommand;
		  }

		  @Override
		  public String getCommandUsage(ICommandSender icommandsender)
		  {
		    return (this.wandCommand+" <show|set <blueprint>|lock|copy <blueprint>>");
		  }

		  @Override
//		  public List getCommandAliases()
		  public List getAliases()
		  {
		    return this.aliases;
		  }

		  @Override
//		  public void processCommand(ICommandSender icommandsender, String[] astring)
		  public void execute(ICommandSender icommandsender, String[] astring)
		  {
			  EntityPlayer player;
	          
	          if(icommandsender instanceof EntityPlayer){
	                  player = (EntityPlayer)icommandsender;
	          } else {
	                  icommandsender.addChatMessage(new ChatComponentText("Player Only Command"));
	                  return;
	          }
	          ItemStack item = player.getCurrentEquippedItem();
	          if (item == null) {
		    	  player.addChatMessage(new ChatComponentText("You are not holding anything"));
	        	  return;
	          }
	          if( !item.getUnlocalizedName().endsWith(Constants.MODID + "_" + ItemWand.name) ) {
		    	  player.addChatMessage(new ChatComponentText("That is not a wand you are holding"));
	        	  return;
	          }
		      if(astring.length < 1)
		      {
		    	  player.addChatMessage(new ChatComponentText("Usage: /wand <show|set <blueprint>|lock|copy <blueprint>>"));
		    	  return;
		      }
		      NBTTagCompound nbt = item.getTagCompound();
		      if( nbt == null ) {
		    		nbt = new NBTTagCompound();
		    		nbt.setString("blueprint", "");
		            nbt.setBoolean("locked",false);
		    		item.setTagCompound(nbt);
		      }
	          if(astring[0].matches("show.*")) {
	        	  //String s = ((ItemWand)item.getItem()).getBlueprint();
	        	  String s = nbt.getString("blueprint");
	        	  if( s == null || s.matches("") ) {
			    	  player.addChatMessage(new ChatComponentText("Wand is not yet enchanted"));
	        	  } else {
			    	  player.addChatMessage(new ChatComponentText("Wand is set to build '"+s+"'"));
			    	  try { ((ItemWand)item.getItem()).enable(); } catch(Exception e) {}
	        	  }
	        	  return;
	          }
		      if( nbt.getBoolean("locked") ) {
		    	  player.addChatMessage(new ChatComponentText("Wand is Locked"));
		    	  return;		    	  
		      }
	          if(astring[0].matches("lock.*")) {
	        	  String s = nbt.getString("blueprint");
	        	  if( s == null || s.matches("") ) {
			    	  player.addChatMessage(new ChatComponentText("Wand is not yet enchanted"));
	        	  } else {
	        		  nbt.setBoolean("locked",true);	        	  
	        		  player.addChatMessage(new ChatComponentText("Wand is now locked"));
	        	  }
	        	  return;
	          }
          
	          if(!astring[0].matches("(set|copy).*")) {
		    	  player.addChatMessage(new ChatComponentText("Invalid subcommand '"+astring[0]+"'.  Should be one of: set, show, lock, copy."));
	        	  return;
	          }

		      if(astring.length < 2) {
		    	  player.addChatMessage(new ChatComponentText("No blueprint name given"));
		    	  return;
		      }
	          if(astring[0].matches("copy.*")) {
				  if( CheshireCat.portfolio.defines(astring[1]) ) {
			    	  player.addChatMessage(new ChatComponentText("Blueprint name '" + astring[1] + "' already exists.  Use '/bp del' first to delete it."));
			    	  return;	    	  
			      }
			      try { ((ItemWand)item.getItem()).initCopyMode(astring[1]); } catch(Exception e) {
			    	  player.addChatMessage(new ChatComponentText("Unable to start copy mode"));			    	  
			    	  return;
			      }
		    	  player.addChatMessage(new ChatComponentText("Copy mode started. Right-click on the first lower corner of the volume to copy."));			    	  
			      return;
	          }
		      // now we can test for a valid blueprint
		      if( ! CheshireCat.portfolio.defines(astring[1]) ) {
		    	  player.addChatMessage(new ChatComponentText("Invalid blueprint name '" + astring[1] + "'"));
		    	  return;	    	  
		      }
		      nbt.setString("blueprint",astring[1]);
		      player.addChatMessage(new ChatComponentText("Wand enchanted to create '" + astring[1] + "'"));
		      try { ((ItemWand)item.getItem()).enable(); } catch(Exception e) {}
		  }

		  @Override
//		  public boolean canCommandSenderUseCommand(ICommandSender icommandsender)
		  public boolean canCommandSenderUse(ICommandSender icommandsender)
		  {
			  // is the player in create mode or holding the wand?
			  EntityPlayer player;
	          
	          if(icommandsender instanceof EntityPlayer){
	                  player = (EntityPlayer)icommandsender;
	          } else {
	                  icommandsender.addChatMessage(new ChatComponentText("Player Only Command"));
	                  return false;
	          }

	          ItemStack item = player.getCurrentEquippedItem();
	          if (item == null) {
	              icommandsender.addChatMessage(new ChatComponentText("You are not holding a wand, or indeed anything"));
				  return false;	        	  
	          }
	          if( item.getUnlocalizedName().endsWith(Constants.MODID + "_" + ItemWand.name) ) {
	        	  return true;
	          }
	          
              icommandsender.addChatMessage(new ChatComponentText("That is not a wand you are holding!"));
			  return false;
		  }

		  @Override
//		  public List addTabCompletionOptions(ICommandSender icommandsender,String[] astring)
		  public List addTabCompletionOptions(ICommandSender icommandsender,String[] astring,BlockPos bp)
		  {
			  if( astring.length > 1 ) {
			  // should add the list of blueprints to them...
				  return CheshireCat.portfolio.list(astring[1]);
			  } else {
				  List l = new ArrayList();
				  l.add("set"); l.add("show");
				  return l;
			  }
		  }

		  @Override
		  public boolean isUsernameIndex(String[] astring, int i)
		  {
			  // none of the parameters are usernames
	   	      return false;
		  }

		  @Override
		  public int compareTo(Object o)
		  {
		      return 0;
		  }
}
